<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item search-item-width-200" placeholder="输入试题名称">
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                        <div style="float: right;">可添加题目量：<span id="canAddCount">0</span></div>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="randomSaveEvent">
                                <i class="fa fa-lg fa-plus"></i> 随机抽取
                            </button>
                            <button type="button" class="layui-btn layui-btn-sm layui-btn-normal" lay-event="manualSaveEvent">
                                <i class="fa fa-lg fa-hand-pointer-o"></i> 手动选择
                            </button>
                            <button type="button" class="layui-btn layui-btn-sm layui-btn-danger" lay-event="clearSaveEvent">
                                <i class="fa fa-lg fa-remove"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var common = layui.common;
        var resizeTimeout = null;
        var queryParams = top.restAjax.params(window.location.href);
        var paperId = queryParams.paperId;
        var questionType = queryParams.questionType;
        var questionChoiceType = queryParams.questionChoiceType;
        var selectCount = queryParams.selectCount;
        var selectedCount = 0;
        var canAddCount = 0;
        var tableUrl = 'api/paper/question/listpage/paper-id/{paperId}?questionType={questionType}&questionChoiceType={questionChoiceType}';

        function getDifficulty(num) {
            var result = '';
            for(var i = 0; i < num; i++) {
                result += '⭐'
            }
            return result;
        }

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, [paperId, questionType, questionChoiceType]),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 60,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'questionSubject', width: 400, title: '试题题目', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'questionType', width: 150, title: '试题种类', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                if(rowData == 'choice') {
                                    return '选择题';
                                } else if(rowData == 'tureOrFalse') {
                                    return '判断题';
                                } else if(rowData == 'fillInTheBlanks') {
                                    return '填空题';
                                } else if(rowData == 'answer') {
                                    return '解答题';
                                }
                                return rowData;
                            }
                        },
                        {field: 'questionChoiceType', width: 150, title: '试题选择类别', align:'center',
                            templet: function(row) {
                                if(row.questionType != 'choice') {
                                    return '-';
                                }
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                if(rowData == 'single') {
                                    return '单选';
                                } else if(rowData == 'multiple') {
                                    return '多选';
                                }
                                return rowData;
                            }
                        },
                        {field: 'questionDifficulty', width: 150, title: '试题难度', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return getDifficulty(rowData);
                            }
                        },
                        {field: 'questionSource', width: 150, title: '试题来源', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'getQuestion', width: 90, title: '详情', fixed: 'right', align:'center', exportType: 'text',
                            templet: function(row) {
                                return '<button class="layui-btn layui-btn layui-btn-xs layui-btn-normal" lay-event="getQuestionEvent"><i class="fa fa-search"></i> 查看</button>';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    selectedCount = data.total;
                    canAddCount = parseInt(selectCount) - parseInt(selectedCount);
                    $('#canAddCount').text(canAddCount);
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val()
                },
                page: {
                    curr: currentPage
                },
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/paper/question/delete/{paperId}/{ids}', [paperId, ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/paper/question/delete/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'randomSaveEvent') {
                top.dialog.msg('将随机抽取该类型试题，原有试题将全部删除，确定操作？', {
                    time: 0,
                    btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                    shade: 0.3,
                    yes: function (index) {
                        top.dialog.close(index);
                        var layIndex;
                        top.restAjax.post(top.restAjax.path('api/paper/question/save-random/paper-id/{paperId}', [paperId]), {
                            questionType: questionType,
                            questionChoiceType: questionChoiceType
                        }, null, function (code, data) {
                            top.dialog.msg('操作成功', {time: 1000});
                            reloadTable();
                        }, function (code, data) {
                            top.dialog.msg(data.msg);
                        }, function () {
                            layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                        }, function () {
                            top.dialog.close(layIndex);
                        });
                    }
                });
            } else if(layEvent === 'manualSaveEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/paper/question/save-select?paperId={paperId}&selectCount={selectCount}&questionType={type}&questionChoiceType={choiceType}', [paperId, canAddCount, questionType, questionChoiceType]),
                    title: '选择试题',
                    width: '75%',
                    height: '80%',
                    onClose: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'clearSaveEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item['paperQuestionId'];
                    }
                    removeData(ids);
                }
            }
        });

        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var event = obj.event;
            if(event === 'getQuestionEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/question/get?questionId={questionId}', [data.questionId]),
                    title: '查看试题，难度：' + getDifficulty(data.questionDifficulty),
                    width: '500px',
                    height: '80%',
                    onClose: function() {
                    }
                });
            }
        })
    });
</script>
</body>
</html>